;angular.module('Landers.angular')
    .directive('labelauty', ['$timeout', 'Flat', 'Helpers', function($timeout, Flat, Helpers) {
        var css_loaded = false;
        return {
            restrict : 'A',
            require : '?ngModel',
            link : function($scope, $ele, $attrs) {
                if (!css_loaded) {
                    Landers.css.add('html input.labelauty + label > span.labelauty-unchecked-image + span.labelauty-unchecked, html input.labelauty + label > span.labelauty-checked-image + span.labelauty-checked {margin-left: 0px; }');
                    Landers.css.add('html input.labelauty + label > span.labelauty-unchecked-image, html input.labelauty + label > span.labelauty-checked-image {background-image:none; }');
                    css_loaded = true;
                }

                var myScope = Helpers.seekScope($scope, parseInt($attrs['useScope']));

                var ngmodel = $attrs['ngModel'];
                if (ngmodel) {
                    $ele.click(function(){
                        var val = $(this).val();
                        Flat.set(myScope, ngmodel, val);
                    });
                }

                setTimeout(function(){
                    var self = arguments.callee;
                    if ($.fn.labelauty) {
                        $ele.labelauty({ same_width:true, label:true });
                    } else {
                        setTimeout(self, 300);
                    }
                }, 300);
            }
        };
    }]);