;angular.module('Landers.angular')
    .directive('landersTreeSelect', ['$timeout', function($timeout) {
        return {
            restrict : 'A',
            require: 'ngModel',
            link : function($scope, $element, $attrs, ngModel){
                    var source = $attrs.source;
                    $scope.$watch(source, function(newValue){
                        $element.children().remove();
                        Landers.treeselect.select({
                            contain: $element, data:newValue, root:['', '选择分类']
                        });
                        var precache = $element.data('precache');
                        $element.val(precache);
                    });
                    angular_scope_apply($scope);

                    $scope.$watch($attrs['ngModel'], function(newValue){
                        $element.data('precache', newValue);
                        $element.val(newValue);
                    });
            }
        };
    }]);