;angular.module('Landers.angular')
    .directive('iscroll', [function(){
        return {
            restrict : 'A',
            link : function($scope, $ele, $attrs) {
                $ele.css({overflow:'hidden'});

                var options = $attrs['iscrollOption'] || '{}';
                options = angular.fromJson(options) || {};
                options = angular.extend({
                    scrollbars: true,
                    mouseWheel: true,
                    click: true
                }, options);

                var styles = $attrs['iscrollStyle'];
                var $wraper = $ele.children(':eq(0)');

                (function(){
                    var self = arguments.callee;
                    if ($wraper.children().length) {
                        new IScroll($ele.get(0), options);
                        setTimeout(function(){
                            $ele.find('.iScrollIndicator').css({
                                border: 'none',
                                width: '4px',
                                right: '0px'
                            }).get(0).style.cssText += styles;
                        }, 100);
                    } else {
                        setTimeout(self, 300);
                    }
                })();
            }
        };
    }]);