;angular.module('Landers.angular')
    .directive('landersTab', ['$timeout', 'Helpers', function($timeout, Helpers) {
        return {
            restrict : 'A',
            scope: {
                'tabModel': '=?',
                'tabCloseEvent': '@',
                'tabOpenEvent': '@'
            },
            link : function($scope, $element, $attrs){
                $timeout(function(){
                    new Landers.tab($element, {
                        active: $scope.tabModel,
                        onClose: function(tab_key){
                            if ($scope.tabCloseEvent) {
                                $scope.$emit($scope.tabCloseEvent, tab_key);
                            }
                        },
                        onOpen: function(tab_key){
                            $timeout(function(){
                                if ($scope.tabOpenEvent) {
                                    $scope.$emit($scope.tabOpenEvent, tab_key);
                                }
                                $scope.tabModel = tab_key;
                            }, 10);
                        }
                    });
                }, 100);
            }
        };
    }]);