;angular.module('Landers.angular')
    .factory('InjectService', ['$ocLazyLoad', '$injector', function($ocLazyLoad, $injector){
        return {
            urls:function(urls, callback){
                $ocLazyLoad.load(urls).then(callback);
            },
            module : function(urls, injects) {
                if (!angular.isArray(injects)) {
                    injects = [injects];
                }

                this.urls(urls, function(){
                    $injector.invoke(injects);
                });
            }
        };
    }]);