;angular.module('Landers.angular')
    .filter('datetime', ['$filter', function($filter){
        return function(input, format) {
            if ( !input ) return;
            if (angular.isNumber(input)) {
                switch (format) {
                    case 'date' : format = 'yyyy-MM-dd'; break;
                    case 'time' : format = 'HH:mm:ss'; break;
                    case 'datetime':
                    default:
                        format = 'yyyy-MM-dd HH:mm:ss'; break;
                }
                return $filter('date')(input * 1000, format);
            } else {
                var arr = input.split(' ');
                switch (format) {
                    case 'date' : return arr[0];
                    case 'time' : return arr[0];
                    case 'datetime':
                    default:
                        return input;
                }
            }
        };
    }]);